#ifndef _H_CCF6A34DBE60D36CFC94FEC0790D2B6B_Direction_DCPS_H_
#define _H_CCF6A34DBE60D36CFC94FEC0790D2B6B_Direction_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Direction_.h"


namespace automotive_navigation_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Direction_TypeSupportInterface;

            typedef Direction_TypeSupportInterface * Direction_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Direction_TypeSupportInterface> Direction_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Direction_TypeSupportInterface> Direction_TypeSupportInterface_out;


            class Direction_DataWriter;

            typedef Direction_DataWriter * Direction_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Direction_DataWriter> Direction_DataWriter_var;
            typedef DDS_DCPSInterface_out < Direction_DataWriter> Direction_DataWriter_out;


            class Direction_DataReader;

            typedef Direction_DataReader * Direction_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Direction_DataReader> Direction_DataReader_var;
            typedef DDS_DCPSInterface_out < Direction_DataReader> Direction_DataReader_out;


            class Direction_DataReaderView;

            typedef Direction_DataReaderView * Direction_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Direction_DataReaderView> Direction_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Direction_DataReaderView> Direction_DataReaderView_out;

            struct Direction_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Direction_, struct Direction_Seq_uniq_> Direction_Seq;
            typedef DDS_DCPSSequence_var < Direction_Seq> Direction_Seq_var;
            typedef DDS_DCPSSequence_out < Direction_Seq> Direction_Seq_out;

            class  Direction_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Direction_TypeSupportInterface_ptr _ptr_type;
                typedef Direction_TypeSupportInterface_var _var_type;

                static Direction_TypeSupportInterface_ptr _duplicate (Direction_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Direction_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Direction_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Direction_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Direction_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Direction_TypeSupportInterface () {};
                ~Direction_TypeSupportInterface () {};
            private:
                Direction_TypeSupportInterface (const Direction_TypeSupportInterface &);
                Direction_TypeSupportInterface & operator = (const Direction_TypeSupportInterface &);
            };

            class  Direction_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Direction_DataWriter_ptr _ptr_type;
                typedef Direction_DataWriter_var _var_type;

                static Direction_DataWriter_ptr _duplicate (Direction_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Direction_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Direction_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Direction_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Direction_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Direction_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Direction_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Direction_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Direction_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Direction_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Direction_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Direction_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Direction_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Direction_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Direction_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Direction_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Direction_& instance_data) = 0;

            protected:
                Direction_DataWriter () {};
                ~Direction_DataWriter () {};
            private:
                Direction_DataWriter (const Direction_DataWriter &);
                Direction_DataWriter & operator = (const Direction_DataWriter &);
            };

            class  Direction_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Direction_DataReader_ptr _ptr_type;
                typedef Direction_DataReader_var _var_type;

                static Direction_DataReader_ptr _duplicate (Direction_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Direction_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Direction_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Direction_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Direction_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Direction_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Direction_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Direction_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Direction_& instance) = 0;

            protected:
                Direction_DataReader () {};
                ~Direction_DataReader () {};
            private:
                Direction_DataReader (const Direction_DataReader &);
                Direction_DataReader & operator = (const Direction_DataReader &);
            };

            class  Direction_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Direction_DataReaderView_ptr _ptr_type;
                typedef Direction_DataReaderView_var _var_type;

                static Direction_DataReaderView_ptr _duplicate (Direction_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Direction_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Direction_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Direction_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Direction_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Direction_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Direction_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Direction_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Direction_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Direction_& instance) = 0;

            protected:
                Direction_DataReaderView () {};
                ~Direction_DataReaderView () {};
            private:
                Direction_DataReaderView (const Direction_DataReaderView &);
                Direction_DataReaderView & operator = (const Direction_DataReaderView &);
            };
        }

    }

}

#endif
