#ifndef _H_B973DB719145AA0F06E9864681AE278E_PointOfInterestArray_DCPS_H_
#define _H_B973DB719145AA0F06E9864681AE278E_PointOfInterestArray_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PointOfInterestArray_.h"


namespace automotive_navigation_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PointOfInterestArray_TypeSupportInterface;

            typedef PointOfInterestArray_TypeSupportInterface * PointOfInterestArray_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterestArray_TypeSupportInterface> PointOfInterestArray_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PointOfInterestArray_TypeSupportInterface> PointOfInterestArray_TypeSupportInterface_out;


            class PointOfInterestArray_DataWriter;

            typedef PointOfInterestArray_DataWriter * PointOfInterestArray_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterestArray_DataWriter> PointOfInterestArray_DataWriter_var;
            typedef DDS_DCPSInterface_out < PointOfInterestArray_DataWriter> PointOfInterestArray_DataWriter_out;


            class PointOfInterestArray_DataReader;

            typedef PointOfInterestArray_DataReader * PointOfInterestArray_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterestArray_DataReader> PointOfInterestArray_DataReader_var;
            typedef DDS_DCPSInterface_out < PointOfInterestArray_DataReader> PointOfInterestArray_DataReader_out;


            class PointOfInterestArray_DataReaderView;

            typedef PointOfInterestArray_DataReaderView * PointOfInterestArray_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterestArray_DataReaderView> PointOfInterestArray_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PointOfInterestArray_DataReaderView> PointOfInterestArray_DataReaderView_out;

            struct PointOfInterestArray_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PointOfInterestArray_, struct PointOfInterestArray_Seq_uniq_> PointOfInterestArray_Seq;
            typedef DDS_DCPSSequence_var < PointOfInterestArray_Seq> PointOfInterestArray_Seq_var;
            typedef DDS_DCPSSequence_out < PointOfInterestArray_Seq> PointOfInterestArray_Seq_out;

            class  PointOfInterestArray_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PointOfInterestArray_TypeSupportInterface_ptr _ptr_type;
                typedef PointOfInterestArray_TypeSupportInterface_var _var_type;

                static PointOfInterestArray_TypeSupportInterface_ptr _duplicate (PointOfInterestArray_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterestArray_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterestArray_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterestArray_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterestArray_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PointOfInterestArray_TypeSupportInterface () {};
                ~PointOfInterestArray_TypeSupportInterface () {};
            private:
                PointOfInterestArray_TypeSupportInterface (const PointOfInterestArray_TypeSupportInterface &);
                PointOfInterestArray_TypeSupportInterface & operator = (const PointOfInterestArray_TypeSupportInterface &);
            };

            class  PointOfInterestArray_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PointOfInterestArray_DataWriter_ptr _ptr_type;
                typedef PointOfInterestArray_DataWriter_var _var_type;

                static PointOfInterestArray_DataWriter_ptr _duplicate (PointOfInterestArray_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterestArray_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterestArray_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterestArray_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterestArray_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PointOfInterestArray_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PointOfInterestArray_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PointOfInterestArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PointOfInterestArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PointOfInterestArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PointOfInterestArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PointOfInterestArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PointOfInterestArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PointOfInterestArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PointOfInterestArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PointOfInterestArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointOfInterestArray_& instance_data) = 0;

            protected:
                PointOfInterestArray_DataWriter () {};
                ~PointOfInterestArray_DataWriter () {};
            private:
                PointOfInterestArray_DataWriter (const PointOfInterestArray_DataWriter &);
                PointOfInterestArray_DataWriter & operator = (const PointOfInterestArray_DataWriter &);
            };

            class  PointOfInterestArray_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PointOfInterestArray_DataReader_ptr _ptr_type;
                typedef PointOfInterestArray_DataReader_var _var_type;

                static PointOfInterestArray_DataReader_ptr _duplicate (PointOfInterestArray_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterestArray_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterestArray_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterestArray_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterestArray_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointOfInterestArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointOfInterestArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointOfInterestArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointOfInterestArray_& instance) = 0;

            protected:
                PointOfInterestArray_DataReader () {};
                ~PointOfInterestArray_DataReader () {};
            private:
                PointOfInterestArray_DataReader (const PointOfInterestArray_DataReader &);
                PointOfInterestArray_DataReader & operator = (const PointOfInterestArray_DataReader &);
            };

            class  PointOfInterestArray_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PointOfInterestArray_DataReaderView_ptr _ptr_type;
                typedef PointOfInterestArray_DataReaderView_var _var_type;

                static PointOfInterestArray_DataReaderView_ptr _duplicate (PointOfInterestArray_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterestArray_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterestArray_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterestArray_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterestArray_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointOfInterestArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointOfInterestArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointOfInterestArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointOfInterestArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointOfInterestArray_& instance) = 0;

            protected:
                PointOfInterestArray_DataReaderView () {};
                ~PointOfInterestArray_DataReaderView () {};
            private:
                PointOfInterestArray_DataReaderView (const PointOfInterestArray_DataReaderView &);
                PointOfInterestArray_DataReaderView & operator = (const PointOfInterestArray_DataReaderView &);
            };
        }

    }

}

#endif
