#ifndef _H_4F391FFDEC10D67463A360C4774D0CA2_PointOfInterestRequest_DCPS_H_
#define _H_4F391FFDEC10D67463A360C4774D0CA2_PointOfInterestRequest_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PointOfInterestRequest_.h"


namespace automotive_navigation_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PointOfInterestRequest_TypeSupportInterface;

            typedef PointOfInterestRequest_TypeSupportInterface * PointOfInterestRequest_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterestRequest_TypeSupportInterface> PointOfInterestRequest_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PointOfInterestRequest_TypeSupportInterface> PointOfInterestRequest_TypeSupportInterface_out;


            class PointOfInterestRequest_DataWriter;

            typedef PointOfInterestRequest_DataWriter * PointOfInterestRequest_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterestRequest_DataWriter> PointOfInterestRequest_DataWriter_var;
            typedef DDS_DCPSInterface_out < PointOfInterestRequest_DataWriter> PointOfInterestRequest_DataWriter_out;


            class PointOfInterestRequest_DataReader;

            typedef PointOfInterestRequest_DataReader * PointOfInterestRequest_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterestRequest_DataReader> PointOfInterestRequest_DataReader_var;
            typedef DDS_DCPSInterface_out < PointOfInterestRequest_DataReader> PointOfInterestRequest_DataReader_out;


            class PointOfInterestRequest_DataReaderView;

            typedef PointOfInterestRequest_DataReaderView * PointOfInterestRequest_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterestRequest_DataReaderView> PointOfInterestRequest_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PointOfInterestRequest_DataReaderView> PointOfInterestRequest_DataReaderView_out;

            struct PointOfInterestRequest_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PointOfInterestRequest_, struct PointOfInterestRequest_Seq_uniq_> PointOfInterestRequest_Seq;
            typedef DDS_DCPSSequence_var < PointOfInterestRequest_Seq> PointOfInterestRequest_Seq_var;
            typedef DDS_DCPSSequence_out < PointOfInterestRequest_Seq> PointOfInterestRequest_Seq_out;

            class  PointOfInterestRequest_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PointOfInterestRequest_TypeSupportInterface_ptr _ptr_type;
                typedef PointOfInterestRequest_TypeSupportInterface_var _var_type;

                static PointOfInterestRequest_TypeSupportInterface_ptr _duplicate (PointOfInterestRequest_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterestRequest_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterestRequest_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterestRequest_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterestRequest_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PointOfInterestRequest_TypeSupportInterface () {};
                ~PointOfInterestRequest_TypeSupportInterface () {};
            private:
                PointOfInterestRequest_TypeSupportInterface (const PointOfInterestRequest_TypeSupportInterface &);
                PointOfInterestRequest_TypeSupportInterface & operator = (const PointOfInterestRequest_TypeSupportInterface &);
            };

            class  PointOfInterestRequest_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PointOfInterestRequest_DataWriter_ptr _ptr_type;
                typedef PointOfInterestRequest_DataWriter_var _var_type;

                static PointOfInterestRequest_DataWriter_ptr _duplicate (PointOfInterestRequest_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterestRequest_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterestRequest_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterestRequest_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterestRequest_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PointOfInterestRequest_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PointOfInterestRequest_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PointOfInterestRequest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PointOfInterestRequest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PointOfInterestRequest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PointOfInterestRequest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PointOfInterestRequest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PointOfInterestRequest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PointOfInterestRequest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PointOfInterestRequest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PointOfInterestRequest_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointOfInterestRequest_& instance_data) = 0;

            protected:
                PointOfInterestRequest_DataWriter () {};
                ~PointOfInterestRequest_DataWriter () {};
            private:
                PointOfInterestRequest_DataWriter (const PointOfInterestRequest_DataWriter &);
                PointOfInterestRequest_DataWriter & operator = (const PointOfInterestRequest_DataWriter &);
            };

            class  PointOfInterestRequest_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PointOfInterestRequest_DataReader_ptr _ptr_type;
                typedef PointOfInterestRequest_DataReader_var _var_type;

                static PointOfInterestRequest_DataReader_ptr _duplicate (PointOfInterestRequest_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterestRequest_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterestRequest_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterestRequest_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterestRequest_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointOfInterestRequest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointOfInterestRequest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointOfInterestRequest_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointOfInterestRequest_& instance) = 0;

            protected:
                PointOfInterestRequest_DataReader () {};
                ~PointOfInterestRequest_DataReader () {};
            private:
                PointOfInterestRequest_DataReader (const PointOfInterestRequest_DataReader &);
                PointOfInterestRequest_DataReader & operator = (const PointOfInterestRequest_DataReader &);
            };

            class  PointOfInterestRequest_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PointOfInterestRequest_DataReaderView_ptr _ptr_type;
                typedef PointOfInterestRequest_DataReaderView_var _var_type;

                static PointOfInterestRequest_DataReaderView_ptr _duplicate (PointOfInterestRequest_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterestRequest_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterestRequest_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterestRequest_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterestRequest_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointOfInterestRequest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointOfInterestRequest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointOfInterestRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointOfInterestRequest_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointOfInterestRequest_& instance) = 0;

            protected:
                PointOfInterestRequest_DataReaderView () {};
                ~PointOfInterestRequest_DataReaderView () {};
            private:
                PointOfInterestRequest_DataReaderView (const PointOfInterestRequest_DataReaderView &);
                PointOfInterestRequest_DataReaderView & operator = (const PointOfInterestRequest_DataReaderView &);
            };
        }

    }

}

#endif
