#ifndef _H_9804C020ABFB51411B6866A59C5EAB57_PointOfInterestResponse_DCPS_H_
#define _H_9804C020ABFB51411B6866A59C5EAB57_PointOfInterestResponse_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PointOfInterestResponse_.h"


namespace automotive_navigation_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PointOfInterestResponse_TypeSupportInterface;

            typedef PointOfInterestResponse_TypeSupportInterface * PointOfInterestResponse_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterestResponse_TypeSupportInterface> PointOfInterestResponse_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PointOfInterestResponse_TypeSupportInterface> PointOfInterestResponse_TypeSupportInterface_out;


            class PointOfInterestResponse_DataWriter;

            typedef PointOfInterestResponse_DataWriter * PointOfInterestResponse_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterestResponse_DataWriter> PointOfInterestResponse_DataWriter_var;
            typedef DDS_DCPSInterface_out < PointOfInterestResponse_DataWriter> PointOfInterestResponse_DataWriter_out;


            class PointOfInterestResponse_DataReader;

            typedef PointOfInterestResponse_DataReader * PointOfInterestResponse_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterestResponse_DataReader> PointOfInterestResponse_DataReader_var;
            typedef DDS_DCPSInterface_out < PointOfInterestResponse_DataReader> PointOfInterestResponse_DataReader_out;


            class PointOfInterestResponse_DataReaderView;

            typedef PointOfInterestResponse_DataReaderView * PointOfInterestResponse_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterestResponse_DataReaderView> PointOfInterestResponse_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PointOfInterestResponse_DataReaderView> PointOfInterestResponse_DataReaderView_out;

            struct PointOfInterestResponse_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PointOfInterestResponse_, struct PointOfInterestResponse_Seq_uniq_> PointOfInterestResponse_Seq;
            typedef DDS_DCPSSequence_var < PointOfInterestResponse_Seq> PointOfInterestResponse_Seq_var;
            typedef DDS_DCPSSequence_out < PointOfInterestResponse_Seq> PointOfInterestResponse_Seq_out;

            class  PointOfInterestResponse_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PointOfInterestResponse_TypeSupportInterface_ptr _ptr_type;
                typedef PointOfInterestResponse_TypeSupportInterface_var _var_type;

                static PointOfInterestResponse_TypeSupportInterface_ptr _duplicate (PointOfInterestResponse_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterestResponse_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterestResponse_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterestResponse_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterestResponse_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PointOfInterestResponse_TypeSupportInterface () {};
                ~PointOfInterestResponse_TypeSupportInterface () {};
            private:
                PointOfInterestResponse_TypeSupportInterface (const PointOfInterestResponse_TypeSupportInterface &);
                PointOfInterestResponse_TypeSupportInterface & operator = (const PointOfInterestResponse_TypeSupportInterface &);
            };

            class  PointOfInterestResponse_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PointOfInterestResponse_DataWriter_ptr _ptr_type;
                typedef PointOfInterestResponse_DataWriter_var _var_type;

                static PointOfInterestResponse_DataWriter_ptr _duplicate (PointOfInterestResponse_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterestResponse_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterestResponse_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterestResponse_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterestResponse_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PointOfInterestResponse_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PointOfInterestResponse_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PointOfInterestResponse_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PointOfInterestResponse_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PointOfInterestResponse_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PointOfInterestResponse_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PointOfInterestResponse_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PointOfInterestResponse_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PointOfInterestResponse_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PointOfInterestResponse_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PointOfInterestResponse_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointOfInterestResponse_& instance_data) = 0;

            protected:
                PointOfInterestResponse_DataWriter () {};
                ~PointOfInterestResponse_DataWriter () {};
            private:
                PointOfInterestResponse_DataWriter (const PointOfInterestResponse_DataWriter &);
                PointOfInterestResponse_DataWriter & operator = (const PointOfInterestResponse_DataWriter &);
            };

            class  PointOfInterestResponse_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PointOfInterestResponse_DataReader_ptr _ptr_type;
                typedef PointOfInterestResponse_DataReader_var _var_type;

                static PointOfInterestResponse_DataReader_ptr _duplicate (PointOfInterestResponse_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterestResponse_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterestResponse_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterestResponse_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterestResponse_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointOfInterestResponse_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointOfInterestResponse_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointOfInterestResponse_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointOfInterestResponse_& instance) = 0;

            protected:
                PointOfInterestResponse_DataReader () {};
                ~PointOfInterestResponse_DataReader () {};
            private:
                PointOfInterestResponse_DataReader (const PointOfInterestResponse_DataReader &);
                PointOfInterestResponse_DataReader & operator = (const PointOfInterestResponse_DataReader &);
            };

            class  PointOfInterestResponse_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PointOfInterestResponse_DataReaderView_ptr _ptr_type;
                typedef PointOfInterestResponse_DataReaderView_var _var_type;

                static PointOfInterestResponse_DataReaderView_ptr _duplicate (PointOfInterestResponse_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterestResponse_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterestResponse_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterestResponse_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterestResponse_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointOfInterestResponse_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointOfInterestResponse_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointOfInterestResponse_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointOfInterestResponse_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointOfInterestResponse_& instance) = 0;

            protected:
                PointOfInterestResponse_DataReaderView () {};
                ~PointOfInterestResponse_DataReaderView () {};
            private:
                PointOfInterestResponse_DataReaderView (const PointOfInterestResponse_DataReaderView &);
                PointOfInterestResponse_DataReaderView & operator = (const PointOfInterestResponse_DataReaderView &);
            };
        }

    }

}

#endif
