#ifndef _H_731BE24A603E1CEDCAA5259FA73E1F30_PointOfInterestStatus_DCPS_H_
#define _H_731BE24A603E1CEDCAA5259FA73E1F30_PointOfInterestStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PointOfInterestStatus_.h"


namespace automotive_navigation_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PointOfInterestStatus_TypeSupportInterface;

            typedef PointOfInterestStatus_TypeSupportInterface * PointOfInterestStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterestStatus_TypeSupportInterface> PointOfInterestStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PointOfInterestStatus_TypeSupportInterface> PointOfInterestStatus_TypeSupportInterface_out;


            class PointOfInterestStatus_DataWriter;

            typedef PointOfInterestStatus_DataWriter * PointOfInterestStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterestStatus_DataWriter> PointOfInterestStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < PointOfInterestStatus_DataWriter> PointOfInterestStatus_DataWriter_out;


            class PointOfInterestStatus_DataReader;

            typedef PointOfInterestStatus_DataReader * PointOfInterestStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterestStatus_DataReader> PointOfInterestStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < PointOfInterestStatus_DataReader> PointOfInterestStatus_DataReader_out;


            class PointOfInterestStatus_DataReaderView;

            typedef PointOfInterestStatus_DataReaderView * PointOfInterestStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterestStatus_DataReaderView> PointOfInterestStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PointOfInterestStatus_DataReaderView> PointOfInterestStatus_DataReaderView_out;

            struct PointOfInterestStatus_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PointOfInterestStatus_, struct PointOfInterestStatus_Seq_uniq_> PointOfInterestStatus_Seq;
            typedef DDS_DCPSSequence_var < PointOfInterestStatus_Seq> PointOfInterestStatus_Seq_var;
            typedef DDS_DCPSSequence_out < PointOfInterestStatus_Seq> PointOfInterestStatus_Seq_out;

            class  PointOfInterestStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PointOfInterestStatus_TypeSupportInterface_ptr _ptr_type;
                typedef PointOfInterestStatus_TypeSupportInterface_var _var_type;

                static PointOfInterestStatus_TypeSupportInterface_ptr _duplicate (PointOfInterestStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterestStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterestStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterestStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterestStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PointOfInterestStatus_TypeSupportInterface () {};
                ~PointOfInterestStatus_TypeSupportInterface () {};
            private:
                PointOfInterestStatus_TypeSupportInterface (const PointOfInterestStatus_TypeSupportInterface &);
                PointOfInterestStatus_TypeSupportInterface & operator = (const PointOfInterestStatus_TypeSupportInterface &);
            };

            class  PointOfInterestStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PointOfInterestStatus_DataWriter_ptr _ptr_type;
                typedef PointOfInterestStatus_DataWriter_var _var_type;

                static PointOfInterestStatus_DataWriter_ptr _duplicate (PointOfInterestStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterestStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterestStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterestStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterestStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PointOfInterestStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PointOfInterestStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PointOfInterestStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PointOfInterestStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PointOfInterestStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PointOfInterestStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PointOfInterestStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PointOfInterestStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PointOfInterestStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PointOfInterestStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PointOfInterestStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointOfInterestStatus_& instance_data) = 0;

            protected:
                PointOfInterestStatus_DataWriter () {};
                ~PointOfInterestStatus_DataWriter () {};
            private:
                PointOfInterestStatus_DataWriter (const PointOfInterestStatus_DataWriter &);
                PointOfInterestStatus_DataWriter & operator = (const PointOfInterestStatus_DataWriter &);
            };

            class  PointOfInterestStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PointOfInterestStatus_DataReader_ptr _ptr_type;
                typedef PointOfInterestStatus_DataReader_var _var_type;

                static PointOfInterestStatus_DataReader_ptr _duplicate (PointOfInterestStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterestStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterestStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterestStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterestStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointOfInterestStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointOfInterestStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointOfInterestStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointOfInterestStatus_& instance) = 0;

            protected:
                PointOfInterestStatus_DataReader () {};
                ~PointOfInterestStatus_DataReader () {};
            private:
                PointOfInterestStatus_DataReader (const PointOfInterestStatus_DataReader &);
                PointOfInterestStatus_DataReader & operator = (const PointOfInterestStatus_DataReader &);
            };

            class  PointOfInterestStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PointOfInterestStatus_DataReaderView_ptr _ptr_type;
                typedef PointOfInterestStatus_DataReaderView_var _var_type;

                static PointOfInterestStatus_DataReaderView_ptr _duplicate (PointOfInterestStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterestStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterestStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterestStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterestStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointOfInterestStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointOfInterestStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointOfInterestStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointOfInterestStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointOfInterestStatus_& instance) = 0;

            protected:
                PointOfInterestStatus_DataReaderView () {};
                ~PointOfInterestStatus_DataReaderView () {};
            private:
                PointOfInterestStatus_DataReaderView (const PointOfInterestStatus_DataReaderView &);
                PointOfInterestStatus_DataReaderView & operator = (const PointOfInterestStatus_DataReaderView &);
            };
        }

    }

}

#endif
