// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from automotive_navigation_msgs:msg/LaneBoundaryArray.idl
// generated code does not contain a copyright notice
#include "automotive_navigation_msgs/msg/lane_boundary_array__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `boundaries`
#include "automotive_navigation_msgs/msg/lane_boundary__functions.h"

bool
automotive_navigation_msgs__msg__LaneBoundaryArray__init(automotive_navigation_msgs__msg__LaneBoundaryArray * msg)
{
  if (!msg) {
    return false;
  }
  // boundaries
  if (!automotive_navigation_msgs__msg__LaneBoundary__Sequence__init(&msg->boundaries, 0)) {
    automotive_navigation_msgs__msg__LaneBoundaryArray__destroy(msg);
    return false;
  }
  return true;
}

void
automotive_navigation_msgs__msg__LaneBoundaryArray__fini(automotive_navigation_msgs__msg__LaneBoundaryArray * msg)
{
  if (!msg) {
    return;
  }
  // boundaries
  automotive_navigation_msgs__msg__LaneBoundary__Sequence__fini(&msg->boundaries);
}

automotive_navigation_msgs__msg__LaneBoundaryArray *
automotive_navigation_msgs__msg__LaneBoundaryArray__create()
{
  automotive_navigation_msgs__msg__LaneBoundaryArray * msg = (automotive_navigation_msgs__msg__LaneBoundaryArray *)malloc(sizeof(automotive_navigation_msgs__msg__LaneBoundaryArray));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_navigation_msgs__msg__LaneBoundaryArray));
  bool success = automotive_navigation_msgs__msg__LaneBoundaryArray__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
automotive_navigation_msgs__msg__LaneBoundaryArray__destroy(automotive_navigation_msgs__msg__LaneBoundaryArray * msg)
{
  if (msg) {
    automotive_navigation_msgs__msg__LaneBoundaryArray__fini(msg);
  }
  free(msg);
}


bool
automotive_navigation_msgs__msg__LaneBoundaryArray__Sequence__init(automotive_navigation_msgs__msg__LaneBoundaryArray__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  automotive_navigation_msgs__msg__LaneBoundaryArray * data = NULL;
  if (size) {
    data = (automotive_navigation_msgs__msg__LaneBoundaryArray *)calloc(size, sizeof(automotive_navigation_msgs__msg__LaneBoundaryArray));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_navigation_msgs__msg__LaneBoundaryArray__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_navigation_msgs__msg__LaneBoundaryArray__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_navigation_msgs__msg__LaneBoundaryArray__Sequence__fini(automotive_navigation_msgs__msg__LaneBoundaryArray__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_navigation_msgs__msg__LaneBoundaryArray__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_navigation_msgs__msg__LaneBoundaryArray__Sequence *
automotive_navigation_msgs__msg__LaneBoundaryArray__Sequence__create(size_t size)
{
  automotive_navigation_msgs__msg__LaneBoundaryArray__Sequence * array = (automotive_navigation_msgs__msg__LaneBoundaryArray__Sequence *)malloc(sizeof(automotive_navigation_msgs__msg__LaneBoundaryArray__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = automotive_navigation_msgs__msg__LaneBoundaryArray__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
automotive_navigation_msgs__msg__LaneBoundaryArray__Sequence__destroy(automotive_navigation_msgs__msg__LaneBoundaryArray__Sequence * array)
{
  if (array) {
    automotive_navigation_msgs__msg__LaneBoundaryArray__Sequence__fini(array);
  }
  free(array);
}
