// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_navigation_msgs:msg/LaneBoundaryArray.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_NAVIGATION_MSGS__MSG__LANE_BOUNDARY_ARRAY__STRUCT_HPP_
#define AUTOMOTIVE_NAVIGATION_MSGS__MSG__LANE_BOUNDARY_ARRAY__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'boundaries'
#include "automotive_navigation_msgs/msg/lane_boundary__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__automotive_navigation_msgs__msg__LaneBoundaryArray __attribute__((deprecated))
#else
# define DEPRECATED__automotive_navigation_msgs__msg__LaneBoundaryArray __declspec(deprecated)
#endif

namespace automotive_navigation_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LaneBoundaryArray_
{
  using Type = LaneBoundaryArray_<ContainerAllocator>;

  explicit LaneBoundaryArray_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit LaneBoundaryArray_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _boundaries_type =
    std::vector<automotive_navigation_msgs::msg::LaneBoundary_<ContainerAllocator>, typename ContainerAllocator::template rebind<automotive_navigation_msgs::msg::LaneBoundary_<ContainerAllocator>>::other>;
  _boundaries_type boundaries;

  // setters for named parameter idiom
  Type & set__boundaries(
    const std::vector<automotive_navigation_msgs::msg::LaneBoundary_<ContainerAllocator>, typename ContainerAllocator::template rebind<automotive_navigation_msgs::msg::LaneBoundary_<ContainerAllocator>>::other> & _arg)
  {
    this->boundaries = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_navigation_msgs::msg::LaneBoundaryArray_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_navigation_msgs::msg::LaneBoundaryArray_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_navigation_msgs::msg::LaneBoundaryArray_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_navigation_msgs::msg::LaneBoundaryArray_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::msg::LaneBoundaryArray_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::msg::LaneBoundaryArray_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::msg::LaneBoundaryArray_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::msg::LaneBoundaryArray_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_navigation_msgs::msg::LaneBoundaryArray_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_navigation_msgs::msg::LaneBoundaryArray_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_navigation_msgs__msg__LaneBoundaryArray
    std::shared_ptr<automotive_navigation_msgs::msg::LaneBoundaryArray_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_navigation_msgs__msg__LaneBoundaryArray
    std::shared_ptr<automotive_navigation_msgs::msg::LaneBoundaryArray_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LaneBoundaryArray_ & other) const
  {
    if (this->boundaries != other.boundaries) {
      return false;
    }
    return true;
  }
  bool operator!=(const LaneBoundaryArray_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LaneBoundaryArray_

// alias to use template instance with default allocator
using LaneBoundaryArray =
  automotive_navigation_msgs::msg::LaneBoundaryArray_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace automotive_navigation_msgs

#endif  // AUTOMOTIVE_NAVIGATION_MSGS__MSG__LANE_BOUNDARY_ARRAY__STRUCT_HPP_
