#ifndef _H_5A171EED5438280B17E84292B4F01E53_GetImageForMapTile_DCPS_H_
#define _H_5A171EED5438280B17E84292B4F01E53_GetImageForMapTile_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetImageForMapTile_.h"


namespace automotive_navigation_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetImageForMapTile_Request_TypeSupportInterface;

            typedef GetImageForMapTile_Request_TypeSupportInterface * GetImageForMapTile_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetImageForMapTile_Request_TypeSupportInterface> GetImageForMapTile_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetImageForMapTile_Request_TypeSupportInterface> GetImageForMapTile_Request_TypeSupportInterface_out;


            class GetImageForMapTile_Request_DataWriter;

            typedef GetImageForMapTile_Request_DataWriter * GetImageForMapTile_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetImageForMapTile_Request_DataWriter> GetImageForMapTile_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetImageForMapTile_Request_DataWriter> GetImageForMapTile_Request_DataWriter_out;


            class GetImageForMapTile_Request_DataReader;

            typedef GetImageForMapTile_Request_DataReader * GetImageForMapTile_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetImageForMapTile_Request_DataReader> GetImageForMapTile_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetImageForMapTile_Request_DataReader> GetImageForMapTile_Request_DataReader_out;


            class GetImageForMapTile_Request_DataReaderView;

            typedef GetImageForMapTile_Request_DataReaderView * GetImageForMapTile_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetImageForMapTile_Request_DataReaderView> GetImageForMapTile_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetImageForMapTile_Request_DataReaderView> GetImageForMapTile_Request_DataReaderView_out;

            struct GetImageForMapTile_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetImageForMapTile_Request_, struct GetImageForMapTile_Request_Seq_uniq_> GetImageForMapTile_Request_Seq;
            typedef DDS_DCPSSequence_var < GetImageForMapTile_Request_Seq> GetImageForMapTile_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetImageForMapTile_Request_Seq> GetImageForMapTile_Request_Seq_out;

            class  GetImageForMapTile_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetImageForMapTile_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetImageForMapTile_Request_TypeSupportInterface_var _var_type;

                static GetImageForMapTile_Request_TypeSupportInterface_ptr _duplicate (GetImageForMapTile_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetImageForMapTile_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetImageForMapTile_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetImageForMapTile_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetImageForMapTile_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetImageForMapTile_Request_TypeSupportInterface () {};
                ~GetImageForMapTile_Request_TypeSupportInterface () {};
            private:
                GetImageForMapTile_Request_TypeSupportInterface (const GetImageForMapTile_Request_TypeSupportInterface &);
                GetImageForMapTile_Request_TypeSupportInterface & operator = (const GetImageForMapTile_Request_TypeSupportInterface &);
            };

            class  GetImageForMapTile_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetImageForMapTile_Request_DataWriter_ptr _ptr_type;
                typedef GetImageForMapTile_Request_DataWriter_var _var_type;

                static GetImageForMapTile_Request_DataWriter_ptr _duplicate (GetImageForMapTile_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetImageForMapTile_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetImageForMapTile_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetImageForMapTile_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetImageForMapTile_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetImageForMapTile_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetImageForMapTile_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetImageForMapTile_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetImageForMapTile_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetImageForMapTile_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetImageForMapTile_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetImageForMapTile_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetImageForMapTile_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetImageForMapTile_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetImageForMapTile_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetImageForMapTile_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetImageForMapTile_Request_& instance_data) = 0;

            protected:
                GetImageForMapTile_Request_DataWriter () {};
                ~GetImageForMapTile_Request_DataWriter () {};
            private:
                GetImageForMapTile_Request_DataWriter (const GetImageForMapTile_Request_DataWriter &);
                GetImageForMapTile_Request_DataWriter & operator = (const GetImageForMapTile_Request_DataWriter &);
            };

            class  GetImageForMapTile_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetImageForMapTile_Request_DataReader_ptr _ptr_type;
                typedef GetImageForMapTile_Request_DataReader_var _var_type;

                static GetImageForMapTile_Request_DataReader_ptr _duplicate (GetImageForMapTile_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetImageForMapTile_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetImageForMapTile_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetImageForMapTile_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetImageForMapTile_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetImageForMapTile_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetImageForMapTile_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetImageForMapTile_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetImageForMapTile_Request_& instance) = 0;

            protected:
                GetImageForMapTile_Request_DataReader () {};
                ~GetImageForMapTile_Request_DataReader () {};
            private:
                GetImageForMapTile_Request_DataReader (const GetImageForMapTile_Request_DataReader &);
                GetImageForMapTile_Request_DataReader & operator = (const GetImageForMapTile_Request_DataReader &);
            };

            class  GetImageForMapTile_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetImageForMapTile_Request_DataReaderView_ptr _ptr_type;
                typedef GetImageForMapTile_Request_DataReaderView_var _var_type;

                static GetImageForMapTile_Request_DataReaderView_ptr _duplicate (GetImageForMapTile_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetImageForMapTile_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetImageForMapTile_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetImageForMapTile_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetImageForMapTile_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetImageForMapTile_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetImageForMapTile_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetImageForMapTile_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetImageForMapTile_Request_& instance) = 0;

            protected:
                GetImageForMapTile_Request_DataReaderView () {};
                ~GetImageForMapTile_Request_DataReaderView () {};
            private:
                GetImageForMapTile_Request_DataReaderView (const GetImageForMapTile_Request_DataReaderView &);
                GetImageForMapTile_Request_DataReaderView & operator = (const GetImageForMapTile_Request_DataReaderView &);
            };
            class GetImageForMapTile_Response_TypeSupportInterface;

            typedef GetImageForMapTile_Response_TypeSupportInterface * GetImageForMapTile_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetImageForMapTile_Response_TypeSupportInterface> GetImageForMapTile_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetImageForMapTile_Response_TypeSupportInterface> GetImageForMapTile_Response_TypeSupportInterface_out;


            class GetImageForMapTile_Response_DataWriter;

            typedef GetImageForMapTile_Response_DataWriter * GetImageForMapTile_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetImageForMapTile_Response_DataWriter> GetImageForMapTile_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetImageForMapTile_Response_DataWriter> GetImageForMapTile_Response_DataWriter_out;


            class GetImageForMapTile_Response_DataReader;

            typedef GetImageForMapTile_Response_DataReader * GetImageForMapTile_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetImageForMapTile_Response_DataReader> GetImageForMapTile_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetImageForMapTile_Response_DataReader> GetImageForMapTile_Response_DataReader_out;


            class GetImageForMapTile_Response_DataReaderView;

            typedef GetImageForMapTile_Response_DataReaderView * GetImageForMapTile_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetImageForMapTile_Response_DataReaderView> GetImageForMapTile_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetImageForMapTile_Response_DataReaderView> GetImageForMapTile_Response_DataReaderView_out;

            struct GetImageForMapTile_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetImageForMapTile_Response_, struct GetImageForMapTile_Response_Seq_uniq_> GetImageForMapTile_Response_Seq;
            typedef DDS_DCPSSequence_var < GetImageForMapTile_Response_Seq> GetImageForMapTile_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetImageForMapTile_Response_Seq> GetImageForMapTile_Response_Seq_out;

            class  GetImageForMapTile_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetImageForMapTile_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetImageForMapTile_Response_TypeSupportInterface_var _var_type;

                static GetImageForMapTile_Response_TypeSupportInterface_ptr _duplicate (GetImageForMapTile_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetImageForMapTile_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetImageForMapTile_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetImageForMapTile_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetImageForMapTile_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetImageForMapTile_Response_TypeSupportInterface () {};
                ~GetImageForMapTile_Response_TypeSupportInterface () {};
            private:
                GetImageForMapTile_Response_TypeSupportInterface (const GetImageForMapTile_Response_TypeSupportInterface &);
                GetImageForMapTile_Response_TypeSupportInterface & operator = (const GetImageForMapTile_Response_TypeSupportInterface &);
            };

            class  GetImageForMapTile_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetImageForMapTile_Response_DataWriter_ptr _ptr_type;
                typedef GetImageForMapTile_Response_DataWriter_var _var_type;

                static GetImageForMapTile_Response_DataWriter_ptr _duplicate (GetImageForMapTile_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetImageForMapTile_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetImageForMapTile_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetImageForMapTile_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetImageForMapTile_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetImageForMapTile_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetImageForMapTile_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetImageForMapTile_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetImageForMapTile_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetImageForMapTile_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetImageForMapTile_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetImageForMapTile_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetImageForMapTile_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetImageForMapTile_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetImageForMapTile_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetImageForMapTile_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetImageForMapTile_Response_& instance_data) = 0;

            protected:
                GetImageForMapTile_Response_DataWriter () {};
                ~GetImageForMapTile_Response_DataWriter () {};
            private:
                GetImageForMapTile_Response_DataWriter (const GetImageForMapTile_Response_DataWriter &);
                GetImageForMapTile_Response_DataWriter & operator = (const GetImageForMapTile_Response_DataWriter &);
            };

            class  GetImageForMapTile_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetImageForMapTile_Response_DataReader_ptr _ptr_type;
                typedef GetImageForMapTile_Response_DataReader_var _var_type;

                static GetImageForMapTile_Response_DataReader_ptr _duplicate (GetImageForMapTile_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetImageForMapTile_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetImageForMapTile_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetImageForMapTile_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetImageForMapTile_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetImageForMapTile_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetImageForMapTile_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetImageForMapTile_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetImageForMapTile_Response_& instance) = 0;

            protected:
                GetImageForMapTile_Response_DataReader () {};
                ~GetImageForMapTile_Response_DataReader () {};
            private:
                GetImageForMapTile_Response_DataReader (const GetImageForMapTile_Response_DataReader &);
                GetImageForMapTile_Response_DataReader & operator = (const GetImageForMapTile_Response_DataReader &);
            };

            class  GetImageForMapTile_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetImageForMapTile_Response_DataReaderView_ptr _ptr_type;
                typedef GetImageForMapTile_Response_DataReaderView_var _var_type;

                static GetImageForMapTile_Response_DataReaderView_ptr _duplicate (GetImageForMapTile_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetImageForMapTile_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetImageForMapTile_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetImageForMapTile_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetImageForMapTile_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetImageForMapTile_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetImageForMapTile_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetImageForMapTile_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetImageForMapTile_Response_& instance) = 0;

            protected:
                GetImageForMapTile_Response_DataReaderView () {};
                ~GetImageForMapTile_Response_DataReaderView () {};
            private:
                GetImageForMapTile_Response_DataReaderView (const GetImageForMapTile_Response_DataReaderView &);
                GetImageForMapTile_Response_DataReaderView & operator = (const GetImageForMapTile_Response_DataReaderView &);
            };
            class Sample_GetImageForMapTile_Request_TypeSupportInterface;

            typedef Sample_GetImageForMapTile_Request_TypeSupportInterface * Sample_GetImageForMapTile_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetImageForMapTile_Request_TypeSupportInterface> Sample_GetImageForMapTile_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetImageForMapTile_Request_TypeSupportInterface> Sample_GetImageForMapTile_Request_TypeSupportInterface_out;


            class Sample_GetImageForMapTile_Request_DataWriter;

            typedef Sample_GetImageForMapTile_Request_DataWriter * Sample_GetImageForMapTile_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetImageForMapTile_Request_DataWriter> Sample_GetImageForMapTile_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetImageForMapTile_Request_DataWriter> Sample_GetImageForMapTile_Request_DataWriter_out;


            class Sample_GetImageForMapTile_Request_DataReader;

            typedef Sample_GetImageForMapTile_Request_DataReader * Sample_GetImageForMapTile_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetImageForMapTile_Request_DataReader> Sample_GetImageForMapTile_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetImageForMapTile_Request_DataReader> Sample_GetImageForMapTile_Request_DataReader_out;


            class Sample_GetImageForMapTile_Request_DataReaderView;

            typedef Sample_GetImageForMapTile_Request_DataReaderView * Sample_GetImageForMapTile_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetImageForMapTile_Request_DataReaderView> Sample_GetImageForMapTile_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetImageForMapTile_Request_DataReaderView> Sample_GetImageForMapTile_Request_DataReaderView_out;

            struct Sample_GetImageForMapTile_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetImageForMapTile_Request_, struct Sample_GetImageForMapTile_Request_Seq_uniq_> Sample_GetImageForMapTile_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetImageForMapTile_Request_Seq> Sample_GetImageForMapTile_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetImageForMapTile_Request_Seq> Sample_GetImageForMapTile_Request_Seq_out;

            class  Sample_GetImageForMapTile_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetImageForMapTile_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetImageForMapTile_Request_TypeSupportInterface_var _var_type;

                static Sample_GetImageForMapTile_Request_TypeSupportInterface_ptr _duplicate (Sample_GetImageForMapTile_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetImageForMapTile_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetImageForMapTile_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetImageForMapTile_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetImageForMapTile_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetImageForMapTile_Request_TypeSupportInterface () {};
                ~Sample_GetImageForMapTile_Request_TypeSupportInterface () {};
            private:
                Sample_GetImageForMapTile_Request_TypeSupportInterface (const Sample_GetImageForMapTile_Request_TypeSupportInterface &);
                Sample_GetImageForMapTile_Request_TypeSupportInterface & operator = (const Sample_GetImageForMapTile_Request_TypeSupportInterface &);
            };

            class  Sample_GetImageForMapTile_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetImageForMapTile_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetImageForMapTile_Request_DataWriter_var _var_type;

                static Sample_GetImageForMapTile_Request_DataWriter_ptr _duplicate (Sample_GetImageForMapTile_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetImageForMapTile_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetImageForMapTile_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetImageForMapTile_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetImageForMapTile_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetImageForMapTile_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetImageForMapTile_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetImageForMapTile_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetImageForMapTile_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetImageForMapTile_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetImageForMapTile_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetImageForMapTile_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetImageForMapTile_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetImageForMapTile_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetImageForMapTile_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetImageForMapTile_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetImageForMapTile_Request_& instance_data) = 0;

            protected:
                Sample_GetImageForMapTile_Request_DataWriter () {};
                ~Sample_GetImageForMapTile_Request_DataWriter () {};
            private:
                Sample_GetImageForMapTile_Request_DataWriter (const Sample_GetImageForMapTile_Request_DataWriter &);
                Sample_GetImageForMapTile_Request_DataWriter & operator = (const Sample_GetImageForMapTile_Request_DataWriter &);
            };

            class  Sample_GetImageForMapTile_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetImageForMapTile_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetImageForMapTile_Request_DataReader_var _var_type;

                static Sample_GetImageForMapTile_Request_DataReader_ptr _duplicate (Sample_GetImageForMapTile_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetImageForMapTile_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetImageForMapTile_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetImageForMapTile_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetImageForMapTile_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetImageForMapTile_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetImageForMapTile_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetImageForMapTile_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetImageForMapTile_Request_& instance) = 0;

            protected:
                Sample_GetImageForMapTile_Request_DataReader () {};
                ~Sample_GetImageForMapTile_Request_DataReader () {};
            private:
                Sample_GetImageForMapTile_Request_DataReader (const Sample_GetImageForMapTile_Request_DataReader &);
                Sample_GetImageForMapTile_Request_DataReader & operator = (const Sample_GetImageForMapTile_Request_DataReader &);
            };

            class  Sample_GetImageForMapTile_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetImageForMapTile_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetImageForMapTile_Request_DataReaderView_var _var_type;

                static Sample_GetImageForMapTile_Request_DataReaderView_ptr _duplicate (Sample_GetImageForMapTile_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetImageForMapTile_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetImageForMapTile_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetImageForMapTile_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetImageForMapTile_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetImageForMapTile_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetImageForMapTile_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetImageForMapTile_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetImageForMapTile_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetImageForMapTile_Request_& instance) = 0;

            protected:
                Sample_GetImageForMapTile_Request_DataReaderView () {};
                ~Sample_GetImageForMapTile_Request_DataReaderView () {};
            private:
                Sample_GetImageForMapTile_Request_DataReaderView (const Sample_GetImageForMapTile_Request_DataReaderView &);
                Sample_GetImageForMapTile_Request_DataReaderView & operator = (const Sample_GetImageForMapTile_Request_DataReaderView &);
            };
            class Sample_GetImageForMapTile_Response_TypeSupportInterface;

            typedef Sample_GetImageForMapTile_Response_TypeSupportInterface * Sample_GetImageForMapTile_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetImageForMapTile_Response_TypeSupportInterface> Sample_GetImageForMapTile_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetImageForMapTile_Response_TypeSupportInterface> Sample_GetImageForMapTile_Response_TypeSupportInterface_out;


            class Sample_GetImageForMapTile_Response_DataWriter;

            typedef Sample_GetImageForMapTile_Response_DataWriter * Sample_GetImageForMapTile_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetImageForMapTile_Response_DataWriter> Sample_GetImageForMapTile_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetImageForMapTile_Response_DataWriter> Sample_GetImageForMapTile_Response_DataWriter_out;


            class Sample_GetImageForMapTile_Response_DataReader;

            typedef Sample_GetImageForMapTile_Response_DataReader * Sample_GetImageForMapTile_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetImageForMapTile_Response_DataReader> Sample_GetImageForMapTile_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetImageForMapTile_Response_DataReader> Sample_GetImageForMapTile_Response_DataReader_out;


            class Sample_GetImageForMapTile_Response_DataReaderView;

            typedef Sample_GetImageForMapTile_Response_DataReaderView * Sample_GetImageForMapTile_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetImageForMapTile_Response_DataReaderView> Sample_GetImageForMapTile_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetImageForMapTile_Response_DataReaderView> Sample_GetImageForMapTile_Response_DataReaderView_out;

            struct Sample_GetImageForMapTile_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetImageForMapTile_Response_, struct Sample_GetImageForMapTile_Response_Seq_uniq_> Sample_GetImageForMapTile_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetImageForMapTile_Response_Seq> Sample_GetImageForMapTile_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetImageForMapTile_Response_Seq> Sample_GetImageForMapTile_Response_Seq_out;

            class  Sample_GetImageForMapTile_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetImageForMapTile_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetImageForMapTile_Response_TypeSupportInterface_var _var_type;

                static Sample_GetImageForMapTile_Response_TypeSupportInterface_ptr _duplicate (Sample_GetImageForMapTile_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetImageForMapTile_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetImageForMapTile_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetImageForMapTile_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetImageForMapTile_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetImageForMapTile_Response_TypeSupportInterface () {};
                ~Sample_GetImageForMapTile_Response_TypeSupportInterface () {};
            private:
                Sample_GetImageForMapTile_Response_TypeSupportInterface (const Sample_GetImageForMapTile_Response_TypeSupportInterface &);
                Sample_GetImageForMapTile_Response_TypeSupportInterface & operator = (const Sample_GetImageForMapTile_Response_TypeSupportInterface &);
            };

            class  Sample_GetImageForMapTile_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetImageForMapTile_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetImageForMapTile_Response_DataWriter_var _var_type;

                static Sample_GetImageForMapTile_Response_DataWriter_ptr _duplicate (Sample_GetImageForMapTile_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetImageForMapTile_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetImageForMapTile_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetImageForMapTile_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetImageForMapTile_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetImageForMapTile_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetImageForMapTile_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetImageForMapTile_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetImageForMapTile_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetImageForMapTile_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetImageForMapTile_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetImageForMapTile_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetImageForMapTile_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetImageForMapTile_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetImageForMapTile_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetImageForMapTile_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetImageForMapTile_Response_& instance_data) = 0;

            protected:
                Sample_GetImageForMapTile_Response_DataWriter () {};
                ~Sample_GetImageForMapTile_Response_DataWriter () {};
            private:
                Sample_GetImageForMapTile_Response_DataWriter (const Sample_GetImageForMapTile_Response_DataWriter &);
                Sample_GetImageForMapTile_Response_DataWriter & operator = (const Sample_GetImageForMapTile_Response_DataWriter &);
            };

            class  Sample_GetImageForMapTile_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetImageForMapTile_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetImageForMapTile_Response_DataReader_var _var_type;

                static Sample_GetImageForMapTile_Response_DataReader_ptr _duplicate (Sample_GetImageForMapTile_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetImageForMapTile_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetImageForMapTile_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetImageForMapTile_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetImageForMapTile_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetImageForMapTile_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetImageForMapTile_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetImageForMapTile_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetImageForMapTile_Response_& instance) = 0;

            protected:
                Sample_GetImageForMapTile_Response_DataReader () {};
                ~Sample_GetImageForMapTile_Response_DataReader () {};
            private:
                Sample_GetImageForMapTile_Response_DataReader (const Sample_GetImageForMapTile_Response_DataReader &);
                Sample_GetImageForMapTile_Response_DataReader & operator = (const Sample_GetImageForMapTile_Response_DataReader &);
            };

            class  Sample_GetImageForMapTile_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetImageForMapTile_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetImageForMapTile_Response_DataReaderView_var _var_type;

                static Sample_GetImageForMapTile_Response_DataReaderView_ptr _duplicate (Sample_GetImageForMapTile_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetImageForMapTile_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetImageForMapTile_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetImageForMapTile_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetImageForMapTile_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetImageForMapTile_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetImageForMapTile_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetImageForMapTile_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetImageForMapTile_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetImageForMapTile_Response_& instance) = 0;

            protected:
                Sample_GetImageForMapTile_Response_DataReaderView () {};
                ~Sample_GetImageForMapTile_Response_DataReaderView () {};
            private:
                Sample_GetImageForMapTile_Response_DataReaderView (const Sample_GetImageForMapTile_Response_DataReaderView &);
                Sample_GetImageForMapTile_Response_DataReaderView & operator = (const Sample_GetImageForMapTile_Response_DataReaderView &);
            };
        }

    }

}

#endif
