// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from automotive_navigation_msgs:srv/GetImageForMapTile.idl
// generated code does not contain a copyright notice
#include "automotive_navigation_msgs/srv/get_image_for_map_tile__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

// Include directives for member types
// Member `tile_id`
#include "rosidl_generator_c/string_functions.h"

bool
automotive_navigation_msgs__srv__GetImageForMapTile_Request__init(automotive_navigation_msgs__srv__GetImageForMapTile_Request * msg)
{
  if (!msg) {
    return false;
  }
  // tile_id
  if (!rosidl_generator_c__String__init(&msg->tile_id)) {
    automotive_navigation_msgs__srv__GetImageForMapTile_Request__destroy(msg);
    return false;
  }
  return true;
}

void
automotive_navigation_msgs__srv__GetImageForMapTile_Request__fini(automotive_navigation_msgs__srv__GetImageForMapTile_Request * msg)
{
  if (!msg) {
    return;
  }
  // tile_id
  rosidl_generator_c__String__fini(&msg->tile_id);
}

automotive_navigation_msgs__srv__GetImageForMapTile_Request *
automotive_navigation_msgs__srv__GetImageForMapTile_Request__create()
{
  automotive_navigation_msgs__srv__GetImageForMapTile_Request * msg = (automotive_navigation_msgs__srv__GetImageForMapTile_Request *)malloc(sizeof(automotive_navigation_msgs__srv__GetImageForMapTile_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_navigation_msgs__srv__GetImageForMapTile_Request));
  bool success = automotive_navigation_msgs__srv__GetImageForMapTile_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
automotive_navigation_msgs__srv__GetImageForMapTile_Request__destroy(automotive_navigation_msgs__srv__GetImageForMapTile_Request * msg)
{
  if (msg) {
    automotive_navigation_msgs__srv__GetImageForMapTile_Request__fini(msg);
  }
  free(msg);
}


bool
automotive_navigation_msgs__srv__GetImageForMapTile_Request__Sequence__init(automotive_navigation_msgs__srv__GetImageForMapTile_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  automotive_navigation_msgs__srv__GetImageForMapTile_Request * data = NULL;
  if (size) {
    data = (automotive_navigation_msgs__srv__GetImageForMapTile_Request *)calloc(size, sizeof(automotive_navigation_msgs__srv__GetImageForMapTile_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_navigation_msgs__srv__GetImageForMapTile_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_navigation_msgs__srv__GetImageForMapTile_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_navigation_msgs__srv__GetImageForMapTile_Request__Sequence__fini(automotive_navigation_msgs__srv__GetImageForMapTile_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_navigation_msgs__srv__GetImageForMapTile_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_navigation_msgs__srv__GetImageForMapTile_Request__Sequence *
automotive_navigation_msgs__srv__GetImageForMapTile_Request__Sequence__create(size_t size)
{
  automotive_navigation_msgs__srv__GetImageForMapTile_Request__Sequence * array = (automotive_navigation_msgs__srv__GetImageForMapTile_Request__Sequence *)malloc(sizeof(automotive_navigation_msgs__srv__GetImageForMapTile_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = automotive_navigation_msgs__srv__GetImageForMapTile_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
automotive_navigation_msgs__srv__GetImageForMapTile_Request__Sequence__destroy(automotive_navigation_msgs__srv__GetImageForMapTile_Request__Sequence * array)
{
  if (array) {
    automotive_navigation_msgs__srv__GetImageForMapTile_Request__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `message`
// already included above
// #include "rosidl_generator_c/string_functions.h"

bool
automotive_navigation_msgs__srv__GetImageForMapTile_Response__init(automotive_navigation_msgs__srv__GetImageForMapTile_Response * msg)
{
  if (!msg) {
    return false;
  }
  // success
  // message
  if (!rosidl_generator_c__String__init(&msg->message)) {
    automotive_navigation_msgs__srv__GetImageForMapTile_Response__destroy(msg);
    return false;
  }
  return true;
}

void
automotive_navigation_msgs__srv__GetImageForMapTile_Response__fini(automotive_navigation_msgs__srv__GetImageForMapTile_Response * msg)
{
  if (!msg) {
    return;
  }
  // success
  // message
  rosidl_generator_c__String__fini(&msg->message);
}

automotive_navigation_msgs__srv__GetImageForMapTile_Response *
automotive_navigation_msgs__srv__GetImageForMapTile_Response__create()
{
  automotive_navigation_msgs__srv__GetImageForMapTile_Response * msg = (automotive_navigation_msgs__srv__GetImageForMapTile_Response *)malloc(sizeof(automotive_navigation_msgs__srv__GetImageForMapTile_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_navigation_msgs__srv__GetImageForMapTile_Response));
  bool success = automotive_navigation_msgs__srv__GetImageForMapTile_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
automotive_navigation_msgs__srv__GetImageForMapTile_Response__destroy(automotive_navigation_msgs__srv__GetImageForMapTile_Response * msg)
{
  if (msg) {
    automotive_navigation_msgs__srv__GetImageForMapTile_Response__fini(msg);
  }
  free(msg);
}


bool
automotive_navigation_msgs__srv__GetImageForMapTile_Response__Sequence__init(automotive_navigation_msgs__srv__GetImageForMapTile_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  automotive_navigation_msgs__srv__GetImageForMapTile_Response * data = NULL;
  if (size) {
    data = (automotive_navigation_msgs__srv__GetImageForMapTile_Response *)calloc(size, sizeof(automotive_navigation_msgs__srv__GetImageForMapTile_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_navigation_msgs__srv__GetImageForMapTile_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_navigation_msgs__srv__GetImageForMapTile_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_navigation_msgs__srv__GetImageForMapTile_Response__Sequence__fini(automotive_navigation_msgs__srv__GetImageForMapTile_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_navigation_msgs__srv__GetImageForMapTile_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_navigation_msgs__srv__GetImageForMapTile_Response__Sequence *
automotive_navigation_msgs__srv__GetImageForMapTile_Response__Sequence__create(size_t size)
{
  automotive_navigation_msgs__srv__GetImageForMapTile_Response__Sequence * array = (automotive_navigation_msgs__srv__GetImageForMapTile_Response__Sequence *)malloc(sizeof(automotive_navigation_msgs__srv__GetImageForMapTile_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = automotive_navigation_msgs__srv__GetImageForMapTile_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
automotive_navigation_msgs__srv__GetImageForMapTile_Response__Sequence__destroy(automotive_navigation_msgs__srv__GetImageForMapTile_Response__Sequence * array)
{
  if (array) {
    automotive_navigation_msgs__srv__GetImageForMapTile_Response__Sequence__fini(array);
  }
  free(array);
}
