#ifndef _H_9167399714877B3E7EE17B0700915740_CommandWithHandshake_DCPS_H_
#define _H_9167399714877B3E7EE17B0700915740_CommandWithHandshake_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CommandWithHandshake_.h"


namespace automotive_navigation_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class CommandWithHandshake_TypeSupportInterface;

            typedef CommandWithHandshake_TypeSupportInterface * CommandWithHandshake_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CommandWithHandshake_TypeSupportInterface> CommandWithHandshake_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CommandWithHandshake_TypeSupportInterface> CommandWithHandshake_TypeSupportInterface_out;


            class CommandWithHandshake_DataWriter;

            typedef CommandWithHandshake_DataWriter * CommandWithHandshake_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CommandWithHandshake_DataWriter> CommandWithHandshake_DataWriter_var;
            typedef DDS_DCPSInterface_out < CommandWithHandshake_DataWriter> CommandWithHandshake_DataWriter_out;


            class CommandWithHandshake_DataReader;

            typedef CommandWithHandshake_DataReader * CommandWithHandshake_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CommandWithHandshake_DataReader> CommandWithHandshake_DataReader_var;
            typedef DDS_DCPSInterface_out < CommandWithHandshake_DataReader> CommandWithHandshake_DataReader_out;


            class CommandWithHandshake_DataReaderView;

            typedef CommandWithHandshake_DataReaderView * CommandWithHandshake_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CommandWithHandshake_DataReaderView> CommandWithHandshake_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CommandWithHandshake_DataReaderView> CommandWithHandshake_DataReaderView_out;

            struct CommandWithHandshake_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < CommandWithHandshake_, struct CommandWithHandshake_Seq_uniq_> CommandWithHandshake_Seq;
            typedef DDS_DCPSSequence_var < CommandWithHandshake_Seq> CommandWithHandshake_Seq_var;
            typedef DDS_DCPSSequence_out < CommandWithHandshake_Seq> CommandWithHandshake_Seq_out;

            class  CommandWithHandshake_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CommandWithHandshake_TypeSupportInterface_ptr _ptr_type;
                typedef CommandWithHandshake_TypeSupportInterface_var _var_type;

                static CommandWithHandshake_TypeSupportInterface_ptr _duplicate (CommandWithHandshake_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CommandWithHandshake_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CommandWithHandshake_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CommandWithHandshake_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CommandWithHandshake_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CommandWithHandshake_TypeSupportInterface () {};
                ~CommandWithHandshake_TypeSupportInterface () {};
            private:
                CommandWithHandshake_TypeSupportInterface (const CommandWithHandshake_TypeSupportInterface &);
                CommandWithHandshake_TypeSupportInterface & operator = (const CommandWithHandshake_TypeSupportInterface &);
            };

            class  CommandWithHandshake_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CommandWithHandshake_DataWriter_ptr _ptr_type;
                typedef CommandWithHandshake_DataWriter_var _var_type;

                static CommandWithHandshake_DataWriter_ptr _duplicate (CommandWithHandshake_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CommandWithHandshake_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CommandWithHandshake_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CommandWithHandshake_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CommandWithHandshake_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CommandWithHandshake_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CommandWithHandshake_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CommandWithHandshake_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CommandWithHandshake_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CommandWithHandshake_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CommandWithHandshake_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CommandWithHandshake_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CommandWithHandshake_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CommandWithHandshake_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CommandWithHandshake_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CommandWithHandshake_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CommandWithHandshake_& instance_data) = 0;

            protected:
                CommandWithHandshake_DataWriter () {};
                ~CommandWithHandshake_DataWriter () {};
            private:
                CommandWithHandshake_DataWriter (const CommandWithHandshake_DataWriter &);
                CommandWithHandshake_DataWriter & operator = (const CommandWithHandshake_DataWriter &);
            };

            class  CommandWithHandshake_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CommandWithHandshake_DataReader_ptr _ptr_type;
                typedef CommandWithHandshake_DataReader_var _var_type;

                static CommandWithHandshake_DataReader_ptr _duplicate (CommandWithHandshake_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CommandWithHandshake_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CommandWithHandshake_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CommandWithHandshake_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CommandWithHandshake_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CommandWithHandshake_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CommandWithHandshake_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CommandWithHandshake_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CommandWithHandshake_& instance) = 0;

            protected:
                CommandWithHandshake_DataReader () {};
                ~CommandWithHandshake_DataReader () {};
            private:
                CommandWithHandshake_DataReader (const CommandWithHandshake_DataReader &);
                CommandWithHandshake_DataReader & operator = (const CommandWithHandshake_DataReader &);
            };

            class  CommandWithHandshake_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CommandWithHandshake_DataReaderView_ptr _ptr_type;
                typedef CommandWithHandshake_DataReaderView_var _var_type;

                static CommandWithHandshake_DataReaderView_ptr _duplicate (CommandWithHandshake_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CommandWithHandshake_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CommandWithHandshake_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CommandWithHandshake_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CommandWithHandshake_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CommandWithHandshake_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CommandWithHandshake_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CommandWithHandshake_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CommandWithHandshake_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CommandWithHandshake_& instance) = 0;

            protected:
                CommandWithHandshake_DataReaderView () {};
                ~CommandWithHandshake_DataReaderView () {};
            private:
                CommandWithHandshake_DataReaderView (const CommandWithHandshake_DataReaderView &);
                CommandWithHandshake_DataReaderView & operator = (const CommandWithHandshake_DataReaderView &);
            };
        }

    }

}

#endif
