#ifndef _H_571B29DEB913660D6D2E6A81A6B4B025_PointOfInterest_DCPS_H_
#define _H_571B29DEB913660D6D2E6A81A6B4B025_PointOfInterest_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PointOfInterest_.h"


namespace automotive_navigation_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PointOfInterest_TypeSupportInterface;

            typedef PointOfInterest_TypeSupportInterface * PointOfInterest_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterest_TypeSupportInterface> PointOfInterest_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PointOfInterest_TypeSupportInterface> PointOfInterest_TypeSupportInterface_out;


            class PointOfInterest_DataWriter;

            typedef PointOfInterest_DataWriter * PointOfInterest_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterest_DataWriter> PointOfInterest_DataWriter_var;
            typedef DDS_DCPSInterface_out < PointOfInterest_DataWriter> PointOfInterest_DataWriter_out;


            class PointOfInterest_DataReader;

            typedef PointOfInterest_DataReader * PointOfInterest_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterest_DataReader> PointOfInterest_DataReader_var;
            typedef DDS_DCPSInterface_out < PointOfInterest_DataReader> PointOfInterest_DataReader_out;


            class PointOfInterest_DataReaderView;

            typedef PointOfInterest_DataReaderView * PointOfInterest_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PointOfInterest_DataReaderView> PointOfInterest_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PointOfInterest_DataReaderView> PointOfInterest_DataReaderView_out;

            struct PointOfInterest_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PointOfInterest_, struct PointOfInterest_Seq_uniq_> PointOfInterest_Seq;
            typedef DDS_DCPSSequence_var < PointOfInterest_Seq> PointOfInterest_Seq_var;
            typedef DDS_DCPSSequence_out < PointOfInterest_Seq> PointOfInterest_Seq_out;

            class  PointOfInterest_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PointOfInterest_TypeSupportInterface_ptr _ptr_type;
                typedef PointOfInterest_TypeSupportInterface_var _var_type;

                static PointOfInterest_TypeSupportInterface_ptr _duplicate (PointOfInterest_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterest_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterest_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterest_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterest_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PointOfInterest_TypeSupportInterface () {};
                ~PointOfInterest_TypeSupportInterface () {};
            private:
                PointOfInterest_TypeSupportInterface (const PointOfInterest_TypeSupportInterface &);
                PointOfInterest_TypeSupportInterface & operator = (const PointOfInterest_TypeSupportInterface &);
            };

            class  PointOfInterest_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PointOfInterest_DataWriter_ptr _ptr_type;
                typedef PointOfInterest_DataWriter_var _var_type;

                static PointOfInterest_DataWriter_ptr _duplicate (PointOfInterest_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterest_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterest_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterest_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterest_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PointOfInterest_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PointOfInterest_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PointOfInterest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PointOfInterest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PointOfInterest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PointOfInterest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PointOfInterest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PointOfInterest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PointOfInterest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PointOfInterest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PointOfInterest_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointOfInterest_& instance_data) = 0;

            protected:
                PointOfInterest_DataWriter () {};
                ~PointOfInterest_DataWriter () {};
            private:
                PointOfInterest_DataWriter (const PointOfInterest_DataWriter &);
                PointOfInterest_DataWriter & operator = (const PointOfInterest_DataWriter &);
            };

            class  PointOfInterest_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PointOfInterest_DataReader_ptr _ptr_type;
                typedef PointOfInterest_DataReader_var _var_type;

                static PointOfInterest_DataReader_ptr _duplicate (PointOfInterest_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterest_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterest_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterest_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterest_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointOfInterest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointOfInterest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointOfInterest_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointOfInterest_& instance) = 0;

            protected:
                PointOfInterest_DataReader () {};
                ~PointOfInterest_DataReader () {};
            private:
                PointOfInterest_DataReader (const PointOfInterest_DataReader &);
                PointOfInterest_DataReader & operator = (const PointOfInterest_DataReader &);
            };

            class  PointOfInterest_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PointOfInterest_DataReaderView_ptr _ptr_type;
                typedef PointOfInterest_DataReaderView_var _var_type;

                static PointOfInterest_DataReaderView_ptr _duplicate (PointOfInterest_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointOfInterest_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PointOfInterest_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointOfInterest_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PointOfInterest_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointOfInterest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointOfInterest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointOfInterest_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointOfInterest_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointOfInterest_& instance) = 0;

            protected:
                PointOfInterest_DataReaderView () {};
                ~PointOfInterest_DataReaderView () {};
            private:
                PointOfInterest_DataReaderView (const PointOfInterest_DataReaderView &);
                PointOfInterest_DataReaderView & operator = (const PointOfInterest_DataReaderView &);
            };
        }

    }

}

#endif
