#ifndef _H_3BE85A25962873F1D608F0750C619723_RoadNetworkBoundaries_DCPS_H_
#define _H_3BE85A25962873F1D608F0750C619723_RoadNetworkBoundaries_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RoadNetworkBoundaries_.h"


namespace automotive_navigation_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RoadNetworkBoundaries_TypeSupportInterface;

            typedef RoadNetworkBoundaries_TypeSupportInterface * RoadNetworkBoundaries_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RoadNetworkBoundaries_TypeSupportInterface> RoadNetworkBoundaries_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RoadNetworkBoundaries_TypeSupportInterface> RoadNetworkBoundaries_TypeSupportInterface_out;


            class RoadNetworkBoundaries_DataWriter;

            typedef RoadNetworkBoundaries_DataWriter * RoadNetworkBoundaries_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RoadNetworkBoundaries_DataWriter> RoadNetworkBoundaries_DataWriter_var;
            typedef DDS_DCPSInterface_out < RoadNetworkBoundaries_DataWriter> RoadNetworkBoundaries_DataWriter_out;


            class RoadNetworkBoundaries_DataReader;

            typedef RoadNetworkBoundaries_DataReader * RoadNetworkBoundaries_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RoadNetworkBoundaries_DataReader> RoadNetworkBoundaries_DataReader_var;
            typedef DDS_DCPSInterface_out < RoadNetworkBoundaries_DataReader> RoadNetworkBoundaries_DataReader_out;


            class RoadNetworkBoundaries_DataReaderView;

            typedef RoadNetworkBoundaries_DataReaderView * RoadNetworkBoundaries_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RoadNetworkBoundaries_DataReaderView> RoadNetworkBoundaries_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RoadNetworkBoundaries_DataReaderView> RoadNetworkBoundaries_DataReaderView_out;

            struct RoadNetworkBoundaries_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RoadNetworkBoundaries_, struct RoadNetworkBoundaries_Seq_uniq_> RoadNetworkBoundaries_Seq;
            typedef DDS_DCPSSequence_var < RoadNetworkBoundaries_Seq> RoadNetworkBoundaries_Seq_var;
            typedef DDS_DCPSSequence_out < RoadNetworkBoundaries_Seq> RoadNetworkBoundaries_Seq_out;

            class  RoadNetworkBoundaries_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RoadNetworkBoundaries_TypeSupportInterface_ptr _ptr_type;
                typedef RoadNetworkBoundaries_TypeSupportInterface_var _var_type;

                static RoadNetworkBoundaries_TypeSupportInterface_ptr _duplicate (RoadNetworkBoundaries_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RoadNetworkBoundaries_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RoadNetworkBoundaries_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RoadNetworkBoundaries_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RoadNetworkBoundaries_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RoadNetworkBoundaries_TypeSupportInterface () {};
                ~RoadNetworkBoundaries_TypeSupportInterface () {};
            private:
                RoadNetworkBoundaries_TypeSupportInterface (const RoadNetworkBoundaries_TypeSupportInterface &);
                RoadNetworkBoundaries_TypeSupportInterface & operator = (const RoadNetworkBoundaries_TypeSupportInterface &);
            };

            class  RoadNetworkBoundaries_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RoadNetworkBoundaries_DataWriter_ptr _ptr_type;
                typedef RoadNetworkBoundaries_DataWriter_var _var_type;

                static RoadNetworkBoundaries_DataWriter_ptr _duplicate (RoadNetworkBoundaries_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RoadNetworkBoundaries_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RoadNetworkBoundaries_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RoadNetworkBoundaries_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RoadNetworkBoundaries_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RoadNetworkBoundaries_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RoadNetworkBoundaries_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RoadNetworkBoundaries_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RoadNetworkBoundaries_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RoadNetworkBoundaries_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RoadNetworkBoundaries_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RoadNetworkBoundaries_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RoadNetworkBoundaries_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RoadNetworkBoundaries_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RoadNetworkBoundaries_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RoadNetworkBoundaries_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RoadNetworkBoundaries_& instance_data) = 0;

            protected:
                RoadNetworkBoundaries_DataWriter () {};
                ~RoadNetworkBoundaries_DataWriter () {};
            private:
                RoadNetworkBoundaries_DataWriter (const RoadNetworkBoundaries_DataWriter &);
                RoadNetworkBoundaries_DataWriter & operator = (const RoadNetworkBoundaries_DataWriter &);
            };

            class  RoadNetworkBoundaries_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RoadNetworkBoundaries_DataReader_ptr _ptr_type;
                typedef RoadNetworkBoundaries_DataReader_var _var_type;

                static RoadNetworkBoundaries_DataReader_ptr _duplicate (RoadNetworkBoundaries_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RoadNetworkBoundaries_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RoadNetworkBoundaries_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RoadNetworkBoundaries_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RoadNetworkBoundaries_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RoadNetworkBoundaries_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RoadNetworkBoundaries_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RoadNetworkBoundaries_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RoadNetworkBoundaries_& instance) = 0;

            protected:
                RoadNetworkBoundaries_DataReader () {};
                ~RoadNetworkBoundaries_DataReader () {};
            private:
                RoadNetworkBoundaries_DataReader (const RoadNetworkBoundaries_DataReader &);
                RoadNetworkBoundaries_DataReader & operator = (const RoadNetworkBoundaries_DataReader &);
            };

            class  RoadNetworkBoundaries_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RoadNetworkBoundaries_DataReaderView_ptr _ptr_type;
                typedef RoadNetworkBoundaries_DataReaderView_var _var_type;

                static RoadNetworkBoundaries_DataReaderView_ptr _duplicate (RoadNetworkBoundaries_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RoadNetworkBoundaries_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RoadNetworkBoundaries_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RoadNetworkBoundaries_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RoadNetworkBoundaries_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RoadNetworkBoundaries_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RoadNetworkBoundaries_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RoadNetworkBoundaries_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RoadNetworkBoundaries_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RoadNetworkBoundaries_& instance) = 0;

            protected:
                RoadNetworkBoundaries_DataReaderView () {};
                ~RoadNetworkBoundaries_DataReaderView () {};
            private:
                RoadNetworkBoundaries_DataReaderView (const RoadNetworkBoundaries_DataReaderView &);
                RoadNetworkBoundaries_DataReaderView & operator = (const RoadNetworkBoundaries_DataReaderView &);
            };
        }

    }

}

#endif
