// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from automotive_navigation_msgs:msg/DistanceToDestination.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_NAVIGATION_MSGS__MSG__DISTANCE_TO_DESTINATION__FUNCTIONS_H_
#define AUTOMOTIVE_NAVIGATION_MSGS__MSG__DISTANCE_TO_DESTINATION__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_generator_c/visibility_control.h"
#include "automotive_navigation_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "automotive_navigation_msgs/msg/distance_to_destination__struct.h"

/// Initialize msg/DistanceToDestination message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * automotive_navigation_msgs__msg__DistanceToDestination
 * )) before or use
 * automotive_navigation_msgs__msg__DistanceToDestination__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
bool
automotive_navigation_msgs__msg__DistanceToDestination__init(automotive_navigation_msgs__msg__DistanceToDestination * msg);

/// Finalize msg/DistanceToDestination message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
void
automotive_navigation_msgs__msg__DistanceToDestination__fini(automotive_navigation_msgs__msg__DistanceToDestination * msg);

/// Create msg/DistanceToDestination message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * automotive_navigation_msgs__msg__DistanceToDestination__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
automotive_navigation_msgs__msg__DistanceToDestination *
automotive_navigation_msgs__msg__DistanceToDestination__create();

/// Destroy msg/DistanceToDestination message.
/**
 * It calls
 * automotive_navigation_msgs__msg__DistanceToDestination__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
void
automotive_navigation_msgs__msg__DistanceToDestination__destroy(automotive_navigation_msgs__msg__DistanceToDestination * msg);


/// Initialize array of msg/DistanceToDestination messages.
/**
 * It allocates the memory for the number of elements and calls
 * automotive_navigation_msgs__msg__DistanceToDestination__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
bool
automotive_navigation_msgs__msg__DistanceToDestination__Sequence__init(automotive_navigation_msgs__msg__DistanceToDestination__Sequence * array, size_t size);

/// Finalize array of msg/DistanceToDestination messages.
/**
 * It calls
 * automotive_navigation_msgs__msg__DistanceToDestination__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
void
automotive_navigation_msgs__msg__DistanceToDestination__Sequence__fini(automotive_navigation_msgs__msg__DistanceToDestination__Sequence * array);

/// Create array of msg/DistanceToDestination messages.
/**
 * It allocates the memory for the array and calls
 * automotive_navigation_msgs__msg__DistanceToDestination__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
automotive_navigation_msgs__msg__DistanceToDestination__Sequence *
automotive_navigation_msgs__msg__DistanceToDestination__Sequence__create(size_t size);

/// Destroy array of msg/DistanceToDestination messages.
/**
 * It calls
 * automotive_navigation_msgs__msg__DistanceToDestination__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
void
automotive_navigation_msgs__msg__DistanceToDestination__Sequence__destroy(automotive_navigation_msgs__msg__DistanceToDestination__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // AUTOMOTIVE_NAVIGATION_MSGS__MSG__DISTANCE_TO_DESTINATION__FUNCTIONS_H_
