// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_navigation_msgs:msg/PointOfInterestResponse.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_NAVIGATION_MSGS__MSG__POINT_OF_INTEREST_RESPONSE__STRUCT_HPP_
#define AUTOMOTIVE_NAVIGATION_MSGS__MSG__POINT_OF_INTEREST_RESPONSE__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"
// Member 'point_statuses'
#include "automotive_navigation_msgs/msg/point_of_interest_status__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__automotive_navigation_msgs__msg__PointOfInterestResponse __attribute__((deprecated))
#else
# define DEPRECATED__automotive_navigation_msgs__msg__PointOfInterestResponse __declspec(deprecated)
#endif

namespace automotive_navigation_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PointOfInterestResponse_
{
  using Type = PointOfInterestResponse_<ContainerAllocator>;

  explicit PointOfInterestResponse_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->module_name = "";
      this->request_id = 0;
      this->update_num = 0;
    }
  }

  explicit PointOfInterestResponse_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    name(_alloc),
    module_name(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->module_name = "";
      this->request_id = 0;
      this->update_num = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _name_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _name_type name;
  using _module_name_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _module_name_type module_name;
  using _request_id_type =
    uint16_t;
  _request_id_type request_id;
  using _update_num_type =
    uint16_t;
  _update_num_type update_num;
  using _point_statuses_type =
    std::vector<automotive_navigation_msgs::msg::PointOfInterestStatus_<ContainerAllocator>, typename ContainerAllocator::template rebind<automotive_navigation_msgs::msg::PointOfInterestStatus_<ContainerAllocator>>::other>;
  _point_statuses_type point_statuses;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__name(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__module_name(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->module_name = _arg;
    return *this;
  }
  Type & set__request_id(
    const uint16_t & _arg)
  {
    this->request_id = _arg;
    return *this;
  }
  Type & set__update_num(
    const uint16_t & _arg)
  {
    this->update_num = _arg;
    return *this;
  }
  Type & set__point_statuses(
    const std::vector<automotive_navigation_msgs::msg::PointOfInterestStatus_<ContainerAllocator>, typename ContainerAllocator::template rebind<automotive_navigation_msgs::msg::PointOfInterestStatus_<ContainerAllocator>>::other> & _arg)
  {
    this->point_statuses = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_navigation_msgs::msg::PointOfInterestResponse_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_navigation_msgs::msg::PointOfInterestResponse_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterestResponse_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterestResponse_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::msg::PointOfInterestResponse_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::msg::PointOfInterestResponse_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::msg::PointOfInterestResponse_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::msg::PointOfInterestResponse_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_navigation_msgs::msg::PointOfInterestResponse_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_navigation_msgs::msg::PointOfInterestResponse_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_navigation_msgs__msg__PointOfInterestResponse
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterestResponse_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_navigation_msgs__msg__PointOfInterestResponse
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterestResponse_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PointOfInterestResponse_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->name != other.name) {
      return false;
    }
    if (this->module_name != other.module_name) {
      return false;
    }
    if (this->request_id != other.request_id) {
      return false;
    }
    if (this->update_num != other.update_num) {
      return false;
    }
    if (this->point_statuses != other.point_statuses) {
      return false;
    }
    return true;
  }
  bool operator!=(const PointOfInterestResponse_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PointOfInterestResponse_

// alias to use template instance with default allocator
using PointOfInterestResponse =
  automotive_navigation_msgs::msg::PointOfInterestResponse_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace automotive_navigation_msgs

#endif  // AUTOMOTIVE_NAVIGATION_MSGS__MSG__POINT_OF_INTEREST_RESPONSE__STRUCT_HPP_
