#ifndef _H_5A171EED5438280B17E84292B4F01E53_GetImageForMapTile__H_
#define _H_5A171EED5438280B17E84292B4F01E53_GetImageForMapTile__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace automotive_navigation_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetImageForMapTile_Request_
            {
                ::DDS::String_mgr tile_id_;
            };

            typedef DDS_DCPSStruct_var<GetImageForMapTile_Request_> GetImageForMapTile_Request__var;
            typedef DDS_DCPSStruct_out < GetImageForMapTile_Request_> GetImageForMapTile_Request__out;

            struct  GetImageForMapTile_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr message_;
            };

            typedef DDS_DCPSStruct_var<GetImageForMapTile_Response_> GetImageForMapTile_Response__var;
            typedef DDS_DCPSStruct_out < GetImageForMapTile_Response_> GetImageForMapTile_Response__out;

            struct  Sample_GetImageForMapTile_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::automotive_navigation_msgs::srv::dds_::GetImageForMapTile_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetImageForMapTile_Request_> Sample_GetImageForMapTile_Request__var;
            typedef DDS_DCPSStruct_out < Sample_GetImageForMapTile_Request_> Sample_GetImageForMapTile_Request__out;

            struct  Sample_GetImageForMapTile_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::automotive_navigation_msgs::srv::dds_::GetImageForMapTile_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetImageForMapTile_Response_> Sample_GetImageForMapTile_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetImageForMapTile_Response_> Sample_GetImageForMapTile_Response__out;

        }

    }

}

#endif /* _H_5A171EED5438280B17E84292B4F01E53_GetImageForMapTile__H_ */
