// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_navigation_msgs:srv/GetImageForMapTile.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_NAVIGATION_MSGS__SRV__GET_IMAGE_FOR_MAP_TILE__STRUCT_HPP_
#define AUTOMOTIVE_NAVIGATION_MSGS__SRV__GET_IMAGE_FOR_MAP_TILE__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__automotive_navigation_msgs__srv__GetImageForMapTile_Request __attribute__((deprecated))
#else
# define DEPRECATED__automotive_navigation_msgs__srv__GetImageForMapTile_Request __declspec(deprecated)
#endif

namespace automotive_navigation_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetImageForMapTile_Request_
{
  using Type = GetImageForMapTile_Request_<ContainerAllocator>;

  explicit GetImageForMapTile_Request_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->tile_id = "";
    }
  }

  explicit GetImageForMapTile_Request_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : tile_id(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->tile_id = "";
    }
  }

  // field types and members
  using _tile_id_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _tile_id_type tile_id;

  // setters for named parameter idiom
  Type & set__tile_id(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->tile_id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_navigation_msgs::srv::GetImageForMapTile_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_navigation_msgs::srv::GetImageForMapTile_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_navigation_msgs::srv::GetImageForMapTile_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_navigation_msgs::srv::GetImageForMapTile_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::srv::GetImageForMapTile_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::srv::GetImageForMapTile_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::srv::GetImageForMapTile_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::srv::GetImageForMapTile_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_navigation_msgs::srv::GetImageForMapTile_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_navigation_msgs::srv::GetImageForMapTile_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_navigation_msgs__srv__GetImageForMapTile_Request
    std::shared_ptr<automotive_navigation_msgs::srv::GetImageForMapTile_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_navigation_msgs__srv__GetImageForMapTile_Request
    std::shared_ptr<automotive_navigation_msgs::srv::GetImageForMapTile_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetImageForMapTile_Request_ & other) const
  {
    if (this->tile_id != other.tile_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetImageForMapTile_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetImageForMapTile_Request_

// alias to use template instance with default allocator
using GetImageForMapTile_Request =
  automotive_navigation_msgs::srv::GetImageForMapTile_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace automotive_navigation_msgs

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__automotive_navigation_msgs__srv__GetImageForMapTile_Response __attribute__((deprecated))
#else
# define DEPRECATED__automotive_navigation_msgs__srv__GetImageForMapTile_Response __declspec(deprecated)
#endif

namespace automotive_navigation_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetImageForMapTile_Response_
{
  using Type = GetImageForMapTile_Response_<ContainerAllocator>;

  explicit GetImageForMapTile_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  explicit GetImageForMapTile_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : message(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _message_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _message_type message;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__message(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->message = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_navigation_msgs::srv::GetImageForMapTile_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_navigation_msgs::srv::GetImageForMapTile_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_navigation_msgs::srv::GetImageForMapTile_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_navigation_msgs::srv::GetImageForMapTile_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::srv::GetImageForMapTile_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::srv::GetImageForMapTile_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::srv::GetImageForMapTile_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::srv::GetImageForMapTile_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_navigation_msgs::srv::GetImageForMapTile_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_navigation_msgs::srv::GetImageForMapTile_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_navigation_msgs__srv__GetImageForMapTile_Response
    std::shared_ptr<automotive_navigation_msgs::srv::GetImageForMapTile_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_navigation_msgs__srv__GetImageForMapTile_Response
    std::shared_ptr<automotive_navigation_msgs::srv::GetImageForMapTile_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetImageForMapTile_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->message != other.message) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetImageForMapTile_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetImageForMapTile_Response_

// alias to use template instance with default allocator
using GetImageForMapTile_Response =
  automotive_navigation_msgs::srv::GetImageForMapTile_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace automotive_navigation_msgs

namespace automotive_navigation_msgs
{

namespace srv
{

struct GetImageForMapTile
{
  using Request = automotive_navigation_msgs::srv::GetImageForMapTile_Request;
  using Response = automotive_navigation_msgs::srv::GetImageForMapTile_Response;
};

}  // namespace srv

}  // namespace automotive_navigation_msgs

#endif  // AUTOMOTIVE_NAVIGATION_MSGS__SRV__GET_IMAGE_FOR_MAP_TILE__STRUCT_HPP_
